#include "coordinate3Dmodifier.h"

Coordinate3DModifier::Coordinate3DModifier(QWidget *parent)
:QWidget(parent)
{
	QLabel *lx = new QLabel("X:");
	sbx = new QDoubleSpinBox;
	sbx->setRange(-500, 500);
	
	QLabel *ly = new QLabel("Y:");
	sby = new QDoubleSpinBox;
	sby->setRange(-500, 500);
	
	QLabel *lz = new QLabel("Z:");
	sbz = new QDoubleSpinBox;
	sbz->setRange(-500, 500);
	
	QHBoxLayout *hblayout = new QHBoxLayout;
	hblayout->addWidget(lx);
	hblayout->addWidget(sbx);
	hblayout->addWidget(ly);
	hblayout->addWidget(sby);
	hblayout->addWidget(lz);
	hblayout->addWidget(sbz);
	hblayout->addStretch();
	
	setLayout(hblayout);
	
	connect(sbx, SIGNAL(valueChanged(double)), this, SLOT(onCoordinateChanged()));
	connect(sby, SIGNAL(valueChanged(double)), this, SLOT(onCoordinateChanged()));
	connect(sbz, SIGNAL(valueChanged(double)), this, SLOT(onCoordinateChanged()));
}

void Coordinate3DModifier::setNewCoordinate(const Ogre::Vector3 &coordinate)
{
	blockSignals(true);
	sbx->setValue(coordinate.x);
	sby->setValue(coordinate.y);
	sbz->setValue(coordinate.z);
	blockSignals(false);
}

void Coordinate3DModifier::onCoordinateChanged()
{
	Ogre::Vector3 newCoord(sbx->value(),
						   sby->value(),
						   sbz->value());
	emit coordinateChanged(newCoord);
}