#include "mycamera.h"

MyCamera::MyCamera(Ogre::Camera &camera, QObject *parent)
:QObject(parent), ogreCamera(&camera)
{
}

Ogre::Camera* MyCamera::getOgreCamera() const
{
    return ogreCamera;
}

const Ogre::Vector3& MyCamera::getPosition() const
{
    return ogreCamera->getPosition();
}

Ogre::Ray MyCamera::getCameraToViewportRay(Ogre::Real screenx, Ogre::Real screeny) const
{
    return ogreCamera->getCameraToViewportRay(screenx, screeny);
}

void MyCamera::setPosition(const Ogre::Vector3 &pos)
{
    ogreCamera->setPosition(pos);
	lookAt(Ogre::Vector3(0,50,0));
    
    emit positionChanged(pos);
    emit visiblePropertyChanged();
}

void MyCamera::lookAt(const Ogre::Vector3 &targetPoint)
{
    ogreCamera->lookAt(targetPoint);
    emit visiblePropertyChanged();
}

void MyCamera::setAspectRatio(Ogre::Real ratio)
{
    ogreCamera->setAspectRatio(ratio);
    emit visiblePropertyChanged();
}
