#ifndef MYCAMERA_H
#define MYCAMERA_H

#include <QObject>
#include <OgreCamera.h>

class MyCamera : public QObject
{
Q_OBJECT

public:
    MyCamera(Ogre::Camera &camera, QObject *parent = 0);
    
    Ogre::Camera* getOgreCamera() const;
    const Ogre::Vector3& getPosition() const;
    Ogre::Ray getCameraToViewportRay(Ogre::Real screenx, Ogre::Real screeny) const;

public slots:
    void setPosition(const Ogre::Vector3 &pos);
    void lookAt(const Ogre::Vector3 &targetPoint);
    void setAspectRatio(Ogre::Real ratio);
    
signals:
    void positionChanged(const Ogre::Vector3 &pos);
    void visiblePropertyChanged();

private:
    Ogre::Camera *ogreCamera;
};

#endif
