#ifndef OGREWIDGET_H
#define OGREWIDGET_H

#include <QtGui>
#include <Ogre.h>

class EventHandler;
class MyCamera;

class OgreWidget : public QWidget
{
    Q_OBJECT
    
public:
    OgreWidget(QWidget *parent = 0);
    ~OgreWidget();
    
    MyCamera *getCamera();
    void setEventHandler(EventHandler *newEventHandler);

public slots:
    void setBackgroundColor(QColor c);

protected:
	virtual void keyPressEvent(QKeyEvent *e);
    virtual void moveEvent(QMoveEvent *e);
    virtual void mouseDoubleClickEvent(QMouseEvent *e);
    virtual void mouseMoveEvent(QMouseEvent *e);
    virtual void mousePressEvent(QMouseEvent *e);
    virtual void mouseReleaseEvent(QMouseEvent *e);
    virtual void paintEvent(QPaintEvent *e);
    virtual void resizeEvent(QResizeEvent *e);
    virtual void showEvent(QShowEvent *e);
    virtual void wheelEvent(QWheelEvent *e);
    
private:
    void initOgreSystem();
	void setupNLoadResources();
	void createScene();
    void setupCamera();

private:
    Ogre::Root          *ogreRoot;
    Ogre::SceneManager  *ogreSceneManager;
    Ogre::RenderWindow  *ogreRenderWindow;
    Ogre::Viewport      *ogreViewport;
	
	EventHandler 		*eventHandler;
    MyCamera            *camera;
	
    Ogre::SceneNode     *selectedNode;
};

#endif OGREWIDGET_H
